# CompSci 107
# Tests the Map implementation, MapWithChaining (which uses separate chaining)

from MapWithChaining import HashTable

#-------------------------------------
# Testing the put() method
# id_names is a list of tuples (id, name)
# This function adds these to the
# hash_t.  the id is the key 
#-------------------------------------
def put_into_hash_t(hash_t):
	id_name_list = get_id_name_list("IDNames.txt")
	for name_id_tuple in id_name_list:
		key = name_id_tuple[0]
		data = name_id_tuple[1]
		hash_t[key] = data

def get_id_name_list(filename):
	name_file = open(filename, 'r')
	id_name_list = []
	all_id_names = name_file.read()
	all_id_names = all_id_names.split('\n')
	for idkey_name in all_id_names:
		key = int(idkey_name[0:8].strip())
		data = idkey_name[9:].strip()
		id_name_list.append((key, data))
	name_file.close()
	return id_name_list
#-------------------------------------
# Print the list in some selected
# hash table slots
#-------------------------------------
def print_some_table_slot_contents(hash_t, slots_to_print):
	slots = hash_t.slots
	data = hash_t.data
	for i in slots_to_print:
		print("Slot ", i, ":", sep="", end=" ")
		the_slot = slots[i]
		corresponding_data = data[i]
		print_list(the_slot, corresponding_data)

def print_list(ids_list, names_list):
	info = ""
	for i in range(len(ids_list)):
		if i > 0:
			info += ", "
		info += str(ids_list[i]) + " " + str(names_list[i])
	print(info)
#-------------------------------------
# Code using the in operator and the
# get() method
#-------------------------------------
def test_get(hash_t):
	print("The two sets of lines should match:")
	list_of_keys = [11280667,  12252533,  12424276,  13203001,  19161898,  \
	20889732,  21920878, 21921542,  22002980,  25035571,  28554617,  31829193,  \
	32407710,  35543684,  43224536,  44038371,  \
	45121103,  57807628,  65109553,  67444120,  \
	70074142,  71039540,  73169236,  84535812, 86102078,  86753922, \
	89263414,  89298881,  91563553,  94621090,  96950736]
	not_found = ""
	found = ""
	for key_to_search in list_of_keys:
		result = hash_t.get(key_to_search)
		if key_to_search in hash_t:
			found += result + " "
		else:
			not_found += str(key_to_search) + " "
	found_to_match = "Found:  Inga Juliann Julina Rustie Frances Catharina Amalia Catherina Eirena Addy Gayel Evangelia Melvin Marsiella Iggy Filippa Tallulah Billy Rodrigo "
	not_found_keys_to_match = "Not found:  12252533 12424276 13203001 31829193 32407710 35543684 44038371 45121103 65109553 71039540 84535812 86102078 "
	print(found_to_match)
	print(not_found_keys_to_match)
	print()
	print("Found: ", found)
	print("Not found: ", not_found)
#-------------------------------------
# Code using the del operator and the
# get() method
#-------------------------------------
def test_delete_add_some(hash_t):
	list_of_keys_to_delete = [73169236,  70074142,  94621090,  43224536,  49259401,  91563553,  21921542,  89298881,  22002980,  11280667]
	list_of_keys_to_search = [73169236,  70074142,  94621090,  43224536,  67444120,  19060070,  73169236,  70074142,  94621090,  22002980,  11280667, 57398651, 12346220]
	id_name_tuples_list = [(57398651 , "Leonard"), (12346220 , "Isis"), (70074142, "Enrico")]
	for key in list_of_keys_to_delete:
		del hash_t[key]
	for name_id_tuple in id_name_tuples_list:
		key = name_id_tuple[0]
		data = name_id_tuple[1]
		hash_t[key] = data
	keys_list = []
	names_list = []
	for key in list_of_keys_to_search:
		if key in hash_t:
			keys_list.append(key)
			names_list.append(hash_t[key])
	print_list(keys_list, names_list)
#-------------------------------------
# Main function
#-------------------------------------
def main():
	hash_t = HashTable(1653)
	print("Add some entries to the hash table")
	put_into_hash_t(hash_t)

	print()	
	print("Print of some of the hashtable slot/data information:")
	print_some_table_slot_contents(hash_t, [12, 100, 139, 156, 176, 231, 490])
	
	print()
	print()
	print("Print the results of the get() method and the in operator:")
	test_get(hash_t)
	
	print()
	print()
	print("Printout the results of the del operator followed by get() method:")
	test_delete_add_some(hash_t)

main()

"""
Add some entries to the hash table

Print of some of the hashtable slot/data information:
Slot 12: 77610281 Kandace, 25017066 Aloysia, 17034747 Glory, 35587418 Nadya, 44034743 Billy, 50104282 Kristina
Slot 100: 94294976 Nanni, 80664543 Bartolomei, 88562443 Camile, 22079703 Beaufort, 36983868 Cornelle, 11261918 Barth
Slot 139: 83829198 Nichole, 94053756 Robinia, 24647657 Tibold, 85803091 Corbin, 88657298 Calli, 90939395 Jennie, 54201823 Joanna, 30127722 Mauricio, 42534588 Lanie, 66803097 Amelie, 27240726 Ideal, 65094667 Isolina
Slot 156: 85912605 Carroll, 25778200 Ambros, 94561074 Towny, 79877387 Sabina, 38217664 Denis, 43899376 Felice, 72604312 Lilia
Slot 176: 70864265 Lemuel, 74696790 Katrinka, 10230379 Lauri, 78828379 Aura, 87980820 Brynne
Slot 231: 76874992 Analiese, 64423141 Radcliffe, 66384058 Jewel, 25016056 Billy
Slot 490: 26385778 Bertie, 44507920 Lorenza, 33267951 Brina


Print the results of the get() method and the in operator:
The two sets of lines should match:
Found:  Inga Juliann Julina Rustie Frances Catharina Amalia Catherina Eirena Addy Gayel Evangelia Melvin Marsiella Iggy Filippa Tallulah Billy Rodrigo 
Not found:  12252533 12424276 13203001 31829193 32407710 35543684 44038371 45121103 65109553 71039540 84535812 86102078 

Found:  Inga Juliann Julina Rustie Frances Catharina Amalia Catherina Eirena Addy Gayel Evangelia Melvin Marsiella Iggy Filippa Tallulah Billy Rodrigo 
Not found:  12252533 12424276 13203001 31829193 32407710 35543684 44038371 45121103 65109553 71039540 84535812 86102078 


Printout the results of the del operator followed by get() method:
70074142 Enrico, 67444120 Gayel, 19060070 Alleen, 70074142 Enrico, 57398651 Leonard, 12346220 Isis
"""