# CompSci 107
# Tests the load factor and other hash table stats:


from MapWithChaining import HashTable

#-------------------------------------
# Add id-names to the hashtable.
# id_names is a list of tuples (id, name)
# This function adds these to the
# hash_t.  the id is the key 
#-------------------------------------
def get_id_name_list(filename):
	name_file = open(filename, 'r')
	id_name_list = []
	all_id_names = name_file.read()
	all_id_names = all_id_names.split('\n')
	for idkey_name in all_id_names:
		key = int(idkey_name[0:8].strip())
		data = idkey_name[9:].strip()
		id_name_list.append((key, data))
	name_file.close()
	return id_name_list

def put_some_into_hash_t(hash_t, how_often):
	id_name_list = get_id_name_list("IDNames.txt")
	add_to_table = how_often
	for name_id_tuple in id_name_list:
		if add_to_table == how_often:
			key = name_id_tuple[0]
			data = name_id_tuple[1]
			hash_t[key] = data
			add_to_table = 0
		add_to_table += 1
#-------------------------------------
# Add id-names to the hashtable.
# id_names is a list of tuples (id, name)
# This function adds these to the
# hash_t.  the id is the key 
#-------------------------------------
def print_tuple_info(num, hash_t):
	info = hash_t.get_hash_table_stats()
	length = len(hash_t)
	load = info[0]
	num_items = info[1]
	min_chain_len = "(" + str(info[2]) + " - " + str(info[3]) + ")"
	max_chain_len = "(" + str(info[4]) + " - " + str(info[5]) + ")"	
	ave_chain_len = info[6]
	zero_len_chains = info[7]
	print("{0:<d}: {1:6.2f} {2:<6d} {3:<9s} {4:<8s} {5:<5.2f} {6:<7d}  ".format(num, load, num_items, min_chain_len, max_chain_len, ave_chain_len, zero_len_chains))
#-------------------------------------
# Main function
#-------------------------------------
def main():
	print("The information displayed:")
	print(" table size, \n (\n   the load factor, \n   total number of items in table, \n   the minimum chain length (how many min length chains), \n   the maximum chain length  (how many min length chains), \n   the average chain length, \n   number of zero length chains\n )")
	print()
	
	hash_t = HashTable(1653)
	print_tuple_info(1, hash_t)
	
	put_some_into_hash_t(hash_t, 1)
	print_tuple_info(2, hash_t)

	hash_t = HashTable(1653)
	put_some_into_hash_t(hash_t, 2)	
	print_tuple_info(3, hash_t)

	hash_t = HashTable(1653)
	put_some_into_hash_t(hash_t, 3)	
	print_tuple_info(4, hash_t)

	hash_t = HashTable(1653)
	put_some_into_hash_t(hash_t, 5)
	print_tuple_info(5, hash_t)

	hash_t = HashTable(1653)
	put_some_into_hash_t(hash_t, 8)
	print_tuple_info(6, hash_t)

	hash_t = HashTable(1653)
	put_some_into_hash_t(hash_t, 10)
	print_tuple_info(7, hash_t)

main()

"""
The information displayed:
 table size, 
 (
   the load factor, 
   total number of items in table, 
   the minimum chain length (how many min length chains), 
   the maximum chain length  (how many min length chains), 
   the average chain length, 
   number of zero length chains
 )

1:   0.00 0      (0 - 0)   (0 - 0)  0.00  1653        
2:   6.05 10000  (1 - 55)  (23 - 1) 6.08  8        
3:   3.02 5000   (1 - 271) (12 - 2) 3.26  117      
4:   2.02 3334   (1 - 451) (9 - 4)  2.39  260      
5:   1.21 2000   (1 - 601) (9 - 1)  1.75  508      
6:   0.76 1250   (1 - 548) (5 - 7)  1.48  806      
7:   0.60 1000   (1 - 541) (5 - 2)  1.35  911
"""
