# CompSci 107
# Tests the improved bubble sort

import random
#-------------------------------------
# Two versions of the bubble sort 
# algorithm
#-------------------------------------
def a_bubble_sort(a_list):
	for end_of_pass in range(len(a_list) - 1, 0, -1):
		for i in range(0, end_of_pass):
			if a_list[i] > a_list[i + 1]:
				a_list[i], a_list[i + 1] = a_list[i + 1], a_list[i]

	return (0, 0)

def improved_bubble_sort(a_list):
	return (0, 0)
#-------------------------------------
# Returns a list of 3000 random numbers 
#-------------------------------------	
def get_random_list():
	a_list = []
	for i in range(3000):
		a_list.append(random.randrange(10, 100000))
	return a_list

def get_list_copy(a_list):
	a_list2 = []
	for num in a_list:
		a_list2.append(num)
	return a_list2
#-------------------------------------
# Main function
#-------------------------------------
def main():
	a_list1 = [30, 46, 33, 35, 42, 36, 44, 55, 78, 80, 93]
	a_list2 = [30, 46, 33, 35, 42, 36, 44, 55, 78, 80, 93]
	print("before: ", a_list1[0:4], "...", a_list1[-3:])
	comparisons1, swaps1 = a_bubble_sort(a_list1)
	comparisons2, swaps2 = improved_bubble_sort(a_list2)
	print("after:  ", a_list1[0:4], "...", a_list1[-3:], a_list1 == a_list2)
	print("Unimproved version: swaps: {0}, comparisons: {1}".format(swaps1, comparisons1))
	print("Improved version:   swaps: {0}, comparisons: {1}".format(swaps2, comparisons2))
	
	print()
	print()
	a_list1 = get_random_list()
	a_list2 = get_list_copy(a_list1)
	print("before: ", a_list1[0:4], "...", a_list1[-3:])
	comparisons1, swaps1 = a_bubble_sort(a_list1)
	comparisons2, swaps2 = improved_bubble_sort(a_list2)
	print("after:  ", a_list1[0:4], "...", a_list1[-3:], a_list1 == a_list2)
	print("Unimproved version: swaps: {0}, comparisons: {1}".format(swaps1, comparisons1))
	print("Improved version:   swaps: {0}, comparisons: {1}".format(swaps2, comparisons2))

main()

"""
before:  [30, 46, 33, 35] ... [78, 80, 93]
after:   [30, 33, 35, 36] ... [78, 80, 93] True
Unimproved version: swaps: 6, comparisons: 55
Improved version:   swaps: 6, comparisons: 27


before:  [43980, 88181, 96721, 92498] ... [7181, 46651, 94093]
after:   [61, 117, 123, 133] ... [99903, 99922, 99998] True
Unimproved version: swaps: 2254565, comparisons: 4498500
Improved version:   swaps: 2254565, comparisons: 4493649
"""

